health.survey.data<- read.csv(file="C:/./Example4.1Data.csv", 
header=TRUE, sep=",")
library("ordinal")

#specifying reference categories
gender.rel<- relevel(health.survey.data$gender, ref="M")
marital.rel<- relevel(health.survey.data$marital, ref="yes")
educ.rel<- relevel(health.survey.data$educ, ref="HSgrad+")

#fitting cumulative logit model
summary(fitted.model<- clm(health ~ gender.rel + age + marital.rel + educ.rel,
data=health.survey.data, link="logit"))

#extracting AICC and BIC for fitted model
p<- 8
n<- 32
print(AICC<- -2*logLik(fitted.model)+2*p*n/(n-p-1))
BIC(fitted.model)

#checking model fit
null.model<- clm(health ~ 1, data=health.survey.data, link="logit")
print(deviance<- -2*(logLik(null.model)-logLik(fitted.model)))
print(p.value<- pchisq(deviance, df=5, lower.tail=FALSE))

#using fitted model for prediction
print(predict(fitted.model, type="prob", data.frame(gender.rel="M", 
age=52, marital.rel="yes", educ.rel="HSgrad")))



