oralhygene.data<- read.csv(file="C:/./Example4.4Data.csv", 
header=TRUE, sep=",")

library(nnet)

#specifying reference categories
gender.rel<- relevel(oralhygene.data$gender, ref="M")
choice.rel<- relevel(oralhygene.data$choice, ref="tartar")

#fitting generalized logits model
summary(fitted.model<- multinom(choice.rel ~ gender.rel + age + nteeth, 
data=oralhygene.data))

#checking model fit
summary(null.model<- multinom(choice.rel ~ 1, data=oralhygene.data))
print(deviance<- deviance(null.model)-deviance(fitted.model))
print(p.value<- pchisq(deviance, df=3, lower.tail=FALSE))

#using fitted model for prediction
print(predict(fitted.model, type="probs",data.frame(gender.rel="M", 
age=49, nteeth=7)))



