bookstore.data<- read.csv(file="C:/./Example5.4Data.csv", 
header=TRUE, sep=",")
library(pscl)

#fitting hurdle Poisson model
summary(fitted.model<- hurdle(ntextbooks ~ aid|renting, 
data=bookstore.data, dist="poisson", zero.dist="binomial",
link="logit"))

#checking model fit
null.model<- hurdle(ntextbooks ~ 1,
data=bookstore.data, dist="poisson", zero.dist="binomial", link="logit")
print(deviance<- -2*(logLik(null.model)-logLik(fitted.model)))
print(p.value<- pchisq(deviance, df=2, lower.tail=FALSE))

#using fitted model for prediction
print(predict(fitted.model, data.frame(renting=0, aid="no")))

