swim.data<- read.csv(file="C:/./Example6.1Data.csv", 
header=TRUE, sep=",")
library(MASS)

#specifying reference category
firsttime.rel<- relevel(swim.data$firsttime, ref="yes")

#fitting negative binomial model
summary(fitted.model<- glm.nb(sets ~ gender + age 
+ firsttime.rel, data=swim.data))

#checking model fit
null.model<- glm.nb(sets ~ 1, data=swim.data)
print(deviance<- -2*(logLik(null.model)-logLik(fitted.model)))
print(p.value<- pchisq(deviance, df=3, lower.tail=FALSE))

#using fitted model for prediction
print(predict(fitted.model, data.frame(gender="F", age=20, 
firsttime.rel="yes"), type="response"))


