weather.data<- read.csv(file="C:/./Example6.3Data.csv", 
header=TRUE, sep=",")

library(pscl)

#fitting zero-inflated negative binomial model
summary(fitted.model<- zeroinfl(snowyears ~ mintemp|elevation, 
data = weather.data, dist = "negbin")) 

#checking model fit
null.model<- zeroinfl(snowyears ~ 1, data=weather.data,dist="negbin")
print(deviance<- -2*(logLik(null.model)-logLik(fitted.model)))
print(p.value<- pchisq(deviance, df=2, lower.tail=FALSE))

#using fitted model for prediction
print(predict(fitted.model,data.frame(elevation=1165.9, mintemp=63.1)))


