creditcards.data<- read.csv(file="C:/./Example6.4Data.csv", 
header=TRUE, sep=",")

library(pscl)

#specifying reference categories
gender.rel<- relevel(creditcards.data$gender, ref="M")
income.rel<- relevel(creditcards.data$income, ref="Low")

#fitting hurdle negative binomial model
summary(fitted.model<- hurdle(ndelinqaccounts ~ gender.rel
+ income.rel + nunemplyears|age,  data=creditcards.data, 
dist="negbin", zero.dist="binomial", link="logit")) 

#checking model fit
null.model<- hurdle(ndelinqaccounts ~ 1,data=creditcards.data, 
dist="negbin",zero.dist="binomial", link="logit")
print(deviance<- -2*(logLik(null.model)-logLik(fitted.model)))
print(p.value<- pchisq(deviance, df=4, lower.tail=FALSE))

#using fitted model for prediction
print(predict(fitted.model, data.frame(age=45, gender.rel="M", 
income.rel="High", nunemplyears=0)))


