medadherence.data<- read.csv(file="C:/./Example7.3Data.csv", 
header=TRUE, sep=",")

library(gamlss)

#computing new variable and making it part of the original data set
medadherence.data$female<- ifelse(medadherence.data$gender=="F",1,0)

#fitting one-inflated beta regression model
summary(fitted.model<- gamlss(pdc  ~ age + female + depression, 
mu.link="logit", nu.formula= ~ diabetes + nmeds, nu.link="logit", 
data=medadherence.data, family=BEOI))

#checking model fit
null.model<- gamlss(pdc  ~ 1, mu.link="logit", nu.formula= ~ 1, 
nu.link="logit", data=medadherence.data, family=BEOI)
print(deviance<- -2*(logLik(null.model)-logLik(fitted.model)))
print(p.value<- pchisq(deviance, df=5, lower.tail=FALSE))

#using fitted model for prediction 
param.pred<- predictAll(fitted.model, newdata=data.frame(age=77,
female=1, depression=0, diabetes=1, nmeds=3), type="response")
print(param.pred$nu+(1-param.pred$nu)*param.pred$mu)


