assignment.data<- read.csv(file="C:/./Example7.4Data.csv", 
header=TRUE, sep=",")

library(gamlss)

#computing new variable and making it part of the original data set
assignment.data$female<- ifelse(assignment.data$gender=="F",1,0)

#fitting zero-one-inflated beta regression model
summary(fitted.model<- gamlss(propassign  ~ female, mu.link="logit", 
nu.formula= ~ mathscore, nu.link="log", tau.formula= ~ grade, tau.link="log",
data=assignment.data, family=BEINF))

#checking model fit
null.model<- gamlss(propassign  ~ 1, mu.link="logit", nu.formula= ~ 1, 
nu.link="log", tau.formula= ~ 1, tau.link="log", data=assignment.data, family=BEINF)
print(deviance<- -2*(logLik(null.model)-logLik(fitted.model)))
print(p.value<- pchisq(deviance, df=3, lower.tail=FALSE))

#using fitted model for prediction 
param.pred<- predictAll(fitted.model, newdata=data.frame(grade=8, mathscore=101, 
female=0), type="response")
print((param.pred$tau+param.pred$mu)/(1+param.pred$nu+param.pred$tau))


