psoriasis.data<- read.csv(file="C:/./Example9.1Data.csv", 
header=TRUE, sep=",")

#creating long-form data set
library(reshape2)
longform.data<- melt(psoriasis.data, id.vars=c("patid", "group"), 
variable.name = "visits", value.name="npatches")

#creating numeric variable for time
weeks<- ifelse(longform.data$visits=="day1", 0.14, ifelse(longform.data$visits
=="week1", 1, ifelse(longform.data$visits=="week2", 2,ifelse(longform.data$visits=="week5", 
5, 13))))

#specifying reference category
group.rel<- relevel(longform.data$group, ref="Tx")

#fitting GEE model with autoregressive working correlation matrix
library(geepack)
library(MuMIn)

summary(ar1.fitted.model<- geeglm(npatches ~ group.rel + weeks, 
data=longform.data, id=patid, family=poisson(link="log"), corstr="ar1"))
QIC(ar1.fitted.model)

#fitting GEE model with exchangeable working correlation matrix
summary(exch.fitted.model<- geeglm(npatches ~ group.rel + weeks, 
data=longform.data, id=patid, family=poisson(link="log"), 
corstr="exchangeable"))
QIC(exch.fitted.model)

#fitting GEE model with independent working correlation matrix
summary(ind.fitted.model<- geeglm(npatches ~ group.rel + weeks, 
data=longform.data, id=patid, family=poisson(link="log"), 
corstr="independence"))
QIC(ind.fitted.model)

#using AR fitted model for prediction
print(predict(ar1.fitted.model, type="response", data.frame(patid=11, 
group.rel="Tx", weeks=5)))
        